VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "CJoin"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'
'   another Join by Damian
'   comments: damian@thewercs.com
'
#Const SKIPEMPTIES = 0
'   change to 1 to have handy "skip empty strings" feature

Private Type TPROC
    hMem As Long
    vtPtr As Long
End Type
Private aProc() As TPROC

Private Declare Function SysReAllocStringLen Lib "oleaut32" (ByVal pbstr As Long, ByVal psz As Long, ByVal cch As Long) As Long
Private Declare Function GlobalAlloc Lib "kernel32" (ByVal wFlags As Long, ByVal dwBytes As Long) As Long
Private Declare Function GlobalLock Lib "kernel32" (ByVal hMem As Long) As Long
Private Declare Function GlobalFree Lib "kernel32" (ByVal hMem As Long) As Long
Private Declare Function GlobalUnlock Lib "kernel32" (ByVal hMem As Long) As Long
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)

Dim i As Long, ub As Long
'Dim cPos As Long, cLen As Long

'   short notes:
'   these long strings with hex numbers are machine codes doing
'   exactly the same as commented VB code below.
'
'   the VB code in these tricky routines (I_AM function) executes
'   only once - at init point. I_AM function installs hook to that
'   class' member VTable entry so all subsequent calls
'   to these members will be forwarded to our machine codes
'
'   btw, if you unwrap this stuff from class factory, you'll gain
'   about 10% more in speed. but it won't be as safe as this. even
'   this code could GPF in one particular way.
'   but I'm not gonna tell you which way it is :)
'
'   optimizing asm codes themselves could gain 2-5% more on huge arrays
'   but the hell with it, it's already fast enough ;)
'
#If SKIPEMPTIES Then
Function SumLen(ByRef v As Variant, ByVal jbL As Long) As Long
    I_AM "53568B7424108B46088B3085F6742A8B5424148B4E108B760C33DBAD85C0" & _
         "740B8B40FC85C0740403D803DAE2EE2BDA72088B742418D1EB891E5E5B33C0C21000"
    'i = LBound(a): ub = UBound(a)
    'For i = UBound(a) To i + 1 Step -1
    '    SumLen = SumLen + Len(a(i)) + jbL
    'Next
    'SumLen = SumLen + Len(a(i))
End Function

Sub GatherIt(ByRef v As Variant, ByVal s As String, ByVal sJB As String)
    I_AM "56578B7424108B46088B308B4E108B760C8B7C24144967E330558B6C241C" & _
         "8BD9AD85C0741F8B48FC8BD196C1E902F3A58BCA83E101F366A58BF58B4E" & _
         "FCD1E9F366A58BF08BCBE2D65DAD85C074138B48FC8BF08BD1C1E902F3A5" & _
         "8BCA83E103F3A45F5E33C0C21000"
    'cPos = 1
    'i = LBound(a): ub = UBound(a)
    'Do Until i >= ub
    '    cLen = Len(a(i))
    '    Mid(s, cPos, cLen) = a(i)
    '    cPos = cPos + cLen
    '    Mid(s, cPos, Len(sJB)) = sJB
    '    cPos = cPos + Len(sJB)
    '    i = i + 1
    'Loop
    'Mid(s, cPos, cLen) = a(i)
    
End Sub
#Else
Function SumLen(ByRef v As Variant, ByVal jbL As Long) As Long
    I_AM "53568B7424108B46088B3085F674228B4424148B4E1049F7E1418B760C8BD8AD85C0" & _
         "74030358FCE2F68B742418D1EB891E5E5B33C0C21000"
End Function

Sub GatherIt(ByRef v As Variant, ByVal s As String, ByVal sJB As String)
    I_AM "56578B7424108B46088B308B4E108B460C8B7C241449742F558B6C241C8BF08BD9AD85C09674118B4EFC8BD1C1E902F3A58BCA83E103F3A48BF58B4EFCD1E9F366A58BCBE2D75D8BF0AD85C074138B48FC8BF08BD1C1E902F3A58BCA83E103F3A45F5E33C0c21000"
End Sub
#End If

Function Join10(a() As String, Optional ByVal JoinBy As String = " ") As String
    ub = LenB(JoinBy)
    i = SumLen(a, ub)
    If i Then
        ub = VarPtr(Join10)
        SysReAllocStringLen ub, 0, i
        GatherIt a, Join10, JoinBy
    End If
End Function

'
'
'
Private Sub I_AM(s As String)
    Dim i As Long, aSize As Long, aB() As Byte
    aSize = Len(s) \ 2
    Debug.Assert aSize Xor 1
    ReDim Preserve aB(1 To aSize)
    For i = 1 To aSize
        aB(i) = Val("&H" & Mid$(s, i * 2 - 1, 2))
    Next
    
    Static cp As Long
    ReDim Preserve aProc(cp)
    Dim hMem As Long, lPtr As Long
    hMem = GlobalAlloc(0, aSize)
    lPtr = GlobalLock(hMem)
    CopyMemory ByVal lPtr, aB(1), aSize
    GlobalUnlock hMem
    
    aProc(cp).hMem = hMem
    aProc(cp).vtPtr = VTable(cp)
    VTable(cp) = lPtr
    cp = cp + 1
End Sub

Private Sub Class_Initialize()
    Dim a(0) As String, s As String
    SumLen a, 0
    GatherIt a, "", ""
End Sub

Private Sub Class_Terminate()
    On Error GoTo E
    Dim i As Long
    For i = 0 To UBound(aProc)
        VTable(i) = aProc(i).vtPtr
        GlobalFree aProc(i).hMem
    Next
E:
End Sub

Private Property Get VTable(ByVal Index As Long) As Long
    Dim p As Long
    Index = &H1C + Index * 4
    CopyMemory p, ByVal ObjPtr(Me), 4
    CopyMemory VTable, ByVal p + Index, 4
End Property

Private Property Let VTable(ByVal Index As Long, ByVal ProcPtr As Long)
    Dim p As Long
    Index = &H1C + Index * 4
    CopyMemory p, ByVal ObjPtr(Me), 4
    CopyMemory ByVal p + Index, ProcPtr, 4
End Property

